package com.gx.obe.evaluation.struct.enumeration;

import java.util.Arrays;
import java.util.Optional;
import java.util.Set;
import java.util.function.Predicate;
import java.util.stream.Collectors;

import com.gx.obe.util.utils.PredicateUtil;


/**
 * @Description: 结构化商务类型
 * @author chenxw
 */
public enum StructBusinessTypeEnum {
	
//	ENTERPRISE_QUALIFICATION("EnterpriseQualification", "企业资质证明文件"),
	
//	EQ_ENTERPRISE_INFO("EQ_EnterpriseInfo", ""),
	
	/**
	 * null
	 */
	NULL("null", ""),
	
	/**
	 * 营业执照 EQ_BusinessLicense
	 */
	EQ_BUSINESS_LICENSE("EQ_BusinessLicense", "营业执照"),
	
	/**
	 * 供货业绩（物资） EQ_Achievements
	 */
	EQ_ACHIEVEMENTS("EQ_Achievements", "供货业绩（物资）"),
	
	/**
	 * 已投产业绩 EQ_OperationAchievements
	 */
	EQ_OPERATION_ACHIEVEMENTS("EQ_OperationAchievements", "已投产业绩"),
	
	/**
	 * 在建业绩（施工/服务） EQ_OperationPerformance
	 */
	EQ_OPERATION_PERFORMANCE("EQ_OperationPerformance", "在建业绩（施工/服务）"),
	
	/**
	 * 合同业绩  EQ_ContractPerformance
	 */
	EQ_CONTRACT_PERFORMANCE("EQ_ContractPerformance", "合同业绩"),
	
	/**
	 * 项目负责人  EQ_ProjectLeader
	 */
	EQ_PROJECTLEADER("EQ_ProjectLeader", "项目负责人"),
	
	/**
	 * 资产负债率 EQ_AssetLiabilityRatio
	 */
	EQ_ASSETLIABILITY_RATIO("EQ_AssetLiabilityRatio", "资产负债率"),
	
	/**
	 * 流动比率 EQ_LiquidityRatio
	 */
	EQ_LIQUIDITY_RATIO("EQ_LiquidityRatio", "流动比率"),
	
	/**
	 * 主营业务利润率 EQ_ProfitRatio
	 */
	EQ_PROFIT_RATIO("EQ_ProfitRatio", "主营业务利润率"),

	/**
	 * 安全生产许可证  EQ_Qualification_SCXK
	 */
	EQ_QUALIFICATION_SCXK("EQ_Qualification_SCXK", "安全生产许可证"),
	
	/**
	 * 检验报告  EQ_Qualification_SurveyReport
	 */
	EQ_QUALIFICATION_SURVEYREPORT("EQ_Qualification_SurveyReport", "检验报告"),
	
	/**
	 *  资信等级 EQ_Qualification_ZXDJ
	 */
	EQ_QUALIFICATION_ZXDJ("EQ_Qualification_ZXDJ", "资信等级"),
	
	/**
	 * 施工资质  EQ_Qualification_SGZZ
	 */
	EQ_QUALIFICATION_SGZZ("EQ_Qualification_SGZZ", "施工资质"),
	
	/**
	 * 设计资质  EQ_Qualification_SJZZ
	 */
	EQ_QUALIFICATION_SJZZ("EQ_Qualification_SJZZ", "设计资质"),
	
	/**
	 * 监理资质  EQ_Qualification_JLZZ
	 */
	EQ_QUALIFICATION_JLZZ("EQ_Qualification_JLZZ", "监理资质"),
	
	/**
	 * 其它资质 EQ_Qualification
	 */
	EQ_QUALIFICATION("EQ_Qualification", "其它资质"),

//	EQ_QUALIFICATION_ZLJX("EQ_Qualification_ZLJX", "质量奖项"),
	
//	EQ_QUALIFICATION_ZLJX_SJ("EQ_Qualification_ZLJX_SJ", "自治区质量奖项"),
	
//	EQ_QUALIFICATION_KJYF("EQ_Qualification_KJYF", "科技研发奖项"),
	
//	EQ_QUALIFICATION_KJYF_SJ("EQ_Qualification_KJYF_SJ", "自治区科技奖项"),
	
//	EQ_QUALIFICATION_HYPM("EQ_Qualification_HYPM", "行业排名"),
	
//	EQ_QUALIFICATION_XJS("EQ_Qualification_XJS", "新技术"),
	
//	EQ_QUALIFICATION_CPRZ("EQ_Qualification_CPRZ", "产品认证证书"),
	
//	EQ_QUALIFICATION_HBTX("EQ_Qualification_HBTX", "环保体系认证证书"),
	
	/**
	 * 投标函   TenderLetter
	 */
	TENDER_LETTER("TenderLetter", "投标函"),

	/**
	 * 法定代表人身份证明  LegalRepresentativeIdCertificate
	 */
	LEGAL_REPRESENTATIVE_ID_CERTIFICATE("LegalRepresentativeIdCertificate", "法定代表人身份证明"),

	/**
	 * 法定代表人授权书  LegalRepresentative
	 */
	LEGAL_REPRESENTATIVE("LegalRepresentative", "法定代表人授权书"),

	/**
	 * 联合体协议书  ConsortiumAgreement
	 */
	CONSORTIUM_AGREEMENT("ConsortiumAgreement", "联合体协议书"),
	
	/**
	 * 投标人关于资格的声明函   BidderQualificationStatement
	 */
	BIDDER_QUALIFICATION_STATEMENT("BidderQualificationStatement", "投标人关于资格的声明函"),
	
	/**
	 * 不存在禁止投标的情形   BidProhibitionSituation
	 */
	BID_PROHIBITION_SITUATION("BidProhibitionSituation", "不存在禁止投标的情形"),

	/**
	 * 投标保证金 BidBond
	 */
	BID_BOND("BidBond", "投标保证金"),
	
	/**
	 * 投标人名称 BidderName
	 */
	BIDDER_NAME("BidderName", "投标人名称"),
	
	/**
	 * 工期 Duration
	 */
	DURATION("Duration", "工期");
	
//	/**
//	 * 发包人要求  ContractorConditions
//	 */
//	CONTRACTOR_CONDITIONS("ContractorConditions", "发包人要求");
//	
//	/**
//	 * 质量标准 QualityStandard
//	 */
//	QUALITY_STANDARD("QualityStandard", "质量标准"),
//
//	/**
//	 * 权利与义务 RightAndDuty
//	 */
//	RIGHT_AND_DUTY("RightAndDuty", "权利与义务"),
//
//	/**
//	 * 分包资格评审   PackQualification
//	 */
//	PACK_QUALIFICATION("PackQualification", "分包资格评审");

	private final String key;
	private final String value;
	
	private StructBusinessTypeEnum(String key, String value) {
		this.key = key;
		this.value = value;
	}
	
	public String getKey() {
		return key;
	}
	
	public String getValue() {
		return value;
	}
	
	/**
	 * @Description: 
	 * @author chenxw
	 * @param object
	 * @return 
	 */
	public static Optional<StructBusinessTypeEnum> getBykey(String key) {
		return Arrays.stream(values()).filter(PredicateUtil.get(StructBusinessTypeEnum::getKey, Predicate.isEqual(key))).findAny();
	}

	private static Set<String> keySet = Arrays.stream(values()).map(StructBusinessTypeEnum::getKey).filter(Predicate.isEqual(NULL.getKey()).negate()).collect(Collectors.toSet());
	
	/**
	 * @Description: 
	 * @author chenxw
	 * @param key
	 * @return 
	 */
	public static boolean contains(String key) {
		return keySet.contains(key);
	}
	
}
