package com.gx.obe.evaluation.struct.enumeration;

import java.util.HashMap;
import java.util.Map;

/** 
 * @Description: 
 * @author chenxw 
 */
public class StructEnum {
	
	/**
	 * 企业资质证明文件
	 */
	public static final String ENTERPRISE_QUALIFICATION = "EnterpriseQualification";
	
	/**
	 * 财务状况
	 */
	public static final String EQ_FINANCIAL_REPORT = "EQ_FinancialReport";
	
	private static Map<String, String> structValueMap = new HashMap<>();
	static {
		structValueMap.put(EQ_FINANCIAL_REPORT, "财务状况");
	}
	
	public static String getStructValue(String dataType) {
		return structValueMap.getOrDefault(dataType, "未知类型");
	}
	
	/**
	 * 未确认
	 */
	public static final String STATE_UNCONFIRMED = "00";
	/**
	 * 有效
	 */
	public static final String STATE_EFFECTIVE = "01";
	/**
	 * 无效
	 */
	public static final String STATE_INVALID = "02";
	
	
	public static final String FLOAT = "float";
	public static final String INT = "int";
	public static final String STRING = "string";
	public static final String DATE_TIME = "datetime";
	public static final String UNION = "union";
	
	
	public static final String IMAGE = "image";
	public static final String ATTACHMENT = "attachment";
	
	
	/**
	 * 资质文件
	 */
	public static final String FICATION = "fication";
	/**
	 * 范本文件
	 */
	public static final String TEMPLATE = "template";
	
	
	public static final String RESPONSE_ITEM = "responseItem";
	
	/**
	 * 	结构化数据修正
	 */
	public static final String  STRUCT_RECORD_TYPE = "00";
	/**
	 * 	结构化明细修正
	 */
	public static final String STRUCT_RECORD_DETAILS = "01";
	
	public static String typeConversion(String dataType) {
		if (StructBusinessTypeEnum.EQ_ASSETLIABILITY_RATIO.getKey().equals(dataType)) return StructEnum.EQ_FINANCIAL_REPORT;
		if (StructBusinessTypeEnum.EQ_LIQUIDITY_RATIO.getKey().equals(dataType)) return StructEnum.EQ_FINANCIAL_REPORT;
		if (StructBusinessTypeEnum.EQ_PROFIT_RATIO.getKey().equals(dataType)) return StructEnum.EQ_FINANCIAL_REPORT;
		if (StructBusinessTypeEnum.BIDDER_NAME.getKey().equals(dataType)) return StructBusinessTypeEnum.EQ_BUSINESS_LICENSE.getKey();
		return dataType;
	}
	
}
